// g++ -std=c++11 -D BINARY_SEARCH_MAIN BinarySearch.cpp -o BinarySearch

#include <algorithm>
#include <fstream>
#include <iostream>
#include <vector>

namespace BinarySearch {
    template <typename T>
    long rank( T key,  std::vector<T> a ) {
        long lo = 0;
        long hi = a.size() - 1;
        while ( lo <= hi ) {
            long mid = lo + ( hi - lo ) /2 ;
            if ( a[mid] < key )
                lo = mid + 1;
            else if ( a[mid] > key )
                hi = mid - 1;
            else
                return mid;
            }
        return -1;
        }
    };

////////////////////////////////////////////////////////////////////////////////

#ifdef BINARY_SEARCH_MAIN

int main( int argc, char **argv ) {
    std::vector<int> whitelist;

    std::fstream whitelist_file( argv[1] );
    while ( whitelist_file.good() ) {
        int i;
        whitelist_file >> i;
        whitelist.push_back(i);
        }
    whitelist_file.close();

    std::sort( whitelist.begin(), whitelist.end() );

    std::cout << "Sorted whitelist" << std::endl;
#if __cplusplus >= 201103
    for ( auto it = whitelist.begin(); it < whitelist.end(); ++it ) {
#else
    for ( std::vector<int>::iterator it = whitelist.begin(); it < whitelist.end(); ++it ) {
#endif
        std::cout << *it  << std::endl;
        }

    while ( ! std::cin.eof() ) {
        int key;
        std::cin >> key;
        if ( BinarySearch::rank( key, whitelist ) > -1 ) {
            std::cout << key << " is in the whitelist" << std::endl;
            }
        }

    }

#endif
