#ifndef RESIZINGARRAYSTACK_HPP
#define RESIZINGARRAYSTACK_HPP

#include <cstddef>

template <typename T>
class ResizingArrayStack {

public:

    ResizingArrayStack( void );
    ~ResizingArrayStack( void );

    void push( T &item );
    T pop( void );

    bool is_empty( void );
    size_t size( void );

    class iterator;
    friend class iterator;
    class iterator {

    public:

        iterator( T *c, T *e );

        iterator& operator++();
        iterator operator++(int);

        T operator*();
        bool operator!=( typename ResizingArrayStack<T>::iterator );

    private:

        T *curr;
        T *end;
        };

    iterator begin( void );
    iterator end( void );

private:

    size_t N;
    size_t max;
    T *data;

    void resize( size_t new_max );
    };



#endif

